import { LitElement, PropertyValueMap } from 'lit';
import * as echarts from 'echarts/core';
import { InputData } from './definition-schema';
import { EChartsOption, SeriesOption } from 'echarts';
type Theme = {
    theme_name: string;
    theme_object: any;
};
type SeriesOptionX = SeriesOption & {
    minDate?: number;
    maxDate?: number;
};
export declare class WidgetLinechart extends LitElement {
    inputData?: InputData;
    theme?: Theme;
    private canvasList;
    private themeBgColor?;
    private themeTitleColor?;
    private themeSubtitleColor?;
    boxes?: HTMLDivElement[];
    origWidth: number;
    origHeight: number;
    template: EChartsOption;
    modifier: number;
    version: string;
    chartContainer: HTMLDivElement | null | undefined;
    resizeObserver?: ResizeObserver;
    constructor();
    update(changedProperties: PropertyValueMap<any> | Map<PropertyKey, unknown>): void;
    protected firstUpdated(_changedProperties: PropertyValueMap<any> | Map<PropertyKey, unknown>): void;
    registerTheme(theme?: Theme): void;
    transformData(): void;
    xAxisType(): 'value' | 'log' | 'category' | 'time' | undefined;
    yAxisType(): 'value' | 'log' | 'category' | undefined;
    applyData(): void;
    deleteCharts(): void;
    setupChart(label: string): {
        echart?: echarts.ECharts;
        series: SeriesOptionX[];
        doomed?: boolean;
        element?: HTMLDivElement;
    } | {
        echart: echarts.ECharts;
        series: SeriesOption[];
        element: HTMLDivElement;
    } | undefined;
    disconnectedCallback(): void;
    static styles: import("lit").CSSResult;
    render(): import("lit-html").TemplateResult<1>;
}
export {};
